function DbControllerServer() {

	this.init = function() {
	};
	
	this.open = function() {
	};
	
	this.close = function() {
	};
	
	this.getNoteList = function(userId, callback) {
		$.ajax({
			'url':'/MyNote',
			'type':'GET',
			'dataType': 'json',
			'data': {
				'user_id' : userId
			}
		}).done(function(data){
			if (data.is_success === 'true') {
				callback(true, data.operation, data.notes);
			} else {
				callback(false, data.error, null);
			}
		}).fail(function(data){
			callback(false, data, null);
		});
	};
	
	this.sendNote = function(userId, text, editKey, callback) {
		var param = {
			'note' : {
				'user_id' : userId,
				'text' : text
			}
		};
		var url;
		if (editKey !== null) {
			param.note.date_time = editKey;
			url = '/MyNote/update_note';
		} else {
			var now = new Date();
			param.note.date_time = Util.date2str(now);
			url = '/MyNote/add_note';
		}
		$.ajax({
			'url' :url,
			'type' :'POST',
			'contentType': 'application/json',
			'dataType': 'json',
			'data' : JSON.stringify(param)
		}).done(function(data){
			if (data.is_success === 'true') {
				callback(true, data.operation, data.note);
			} else {
				callback(false, data.error, null);
			}
		}).fail(function(data){
			callback(false, data, null);
		});
	};

	this.deleteNote = function(userId, keyDateTime, callback) {
		var param = {
			'note': {
				'user_id' : userId,
				'date_time' : keyDateTime
			}
		};
		$.ajax({
			'url' : '/MyNote/delete_note',
			'type' :'POST',
			'contentType': 'application/json',
			'dataType': 'json',
			'data' : JSON.stringify(param)
		}).done(function(data){
			if (data.is_success === 'true') {
				callback(true, data.operation, data.note);
			} else {
				callback(false, data.error, null);
			}
		}).fail(function(data){
			callback(false, data, null);
		});
	};

	this.clearAllNote = function(userId, callback) {
		$.ajax({
			'url':'/MyNote',
			'type':'DELETE',
			'dataType': 'json',
			'data' : {
				'user_id' : userId
			}
		}).done(function(data){
			if (data.is_success === 'true') {
				callback(true, null, null);
			} else {
				callback(false, data.error, null);
			}
		}).fail(function(data){
			callback(false, data, null);
		});
	};
}
