function MyNoteDoc() {
	var m_noteList = [];
	var m_noteNo = 0;
	var m_view = null;
	var m_userId = null;
	var m_editKey = null;
	var m_dbController = null;
	var m_isLogIn = false;

	this.init = function () {
	};

	this.setView = function(view) {
		m_view = view;
	};

	this.getNoteList = function() {
		return m_noteList;
	};

	this.setUserId = function(userId) {
		m_userId = userId;
	};

	this.getUserId = function() {
		return m_userId;
	}

	this.setDbController = function(dbController) {
		m_dbController = dbController;
	};

	this.open = function() {
		if (m_dbController) {
			m_dbController.open();
		}
	};

	this.close = function() {
		if (m_dbController) {
			m_dbController.close();
		}
	};

	this.setEditIndex = function(index) {
		if (index >= m_noteList.length) {
			console.log("out of index[" + index + "]");
		} else {
			m_editKey = m_noteList[index].data.date_time;
		}
	};

	this.loadNote = function() {
		if (m_userId === null) {
			clearNote();
			return;
		}
		m_dbController.getNoteList(m_userId, function(isSuccess, param1, param2) {
			if (isSuccess) {
				console.log('getNoteList operation:' + param1 + ' note:' + JSON.stringify(param2, null, 2));
				updateNotes(param1, param2);
			} else {
				console.log('getNoteList failed:' + JSON.stringify(param1));
				clearNote();
				m_view.updateInfo();
				alert('error!!!');
			}
		});
	};

	function clearNote() {
		m_noteList = [];
		m_view.clearNote();
	}

	function updateNotes(operation, notes) {
		if (operation === 'new') {
			clearNote();
		}
		var index = m_noteList.length;
		for (var i = 0; i < notes.length; i++) {
			var updateIndex = findNote(notes[i]);
			if (updateIndex >= 0) {
				m_noteList[updateIndex].data = notes[i];
				m_view.updateNote(m_userId, updateIndex);
			} else {
				m_noteNo++;
				m_noteList.push({'no': m_noteNo, 'name': 'note_' + m_noteNo, 'data': notes[i], 'disp_text': ''});
				m_view.addNote(m_userId, index);
				index++;
			}
		}
	}

	function findNote(note) {
		for (var i = 0; i < m_noteList.length; i++) {
			if (m_noteList[i].data.date_time === note.date_time) {
				return i;
			}
		}
		return -1;
	}

	function send(text) {
		if (m_userId === null) {
			return;
		}
		console.log("send text=", text);
		m_dbController.sendNote(m_userId, text, m_editKey, function(isSuccess, param1, param2) {
			if (isSuccess) {
				console.log('sendNote operation:' + param1 + " note:" + JSON.stringify(param2, null, 2));
				var notes = [];
				notes.push(param2);
				updateNotes(param1, notes);
			} else {
				console.log('sendNote failed:' + JSON.stringify(param1));
				alert('error!!!');
			}
		});
	}

	this.sendPlaneText = function(text) {
		send(text);
		m_editKey = null;
	};

	this.clearAllNote = function() {
		if (m_userId === null) {
			return;
		}
		m_dbController.clearAllNote(m_userId, function(isSuccess) {
			if (isSuccess) {
				console.log("clearAllNote succeeded");
				clearNote();
			} else {
				console.log("clearAllNote failed:" + JSON.stringify(param1));
				alert('error!!!');
			}
		});
	};

	this.deleteNote = function(index) {
		if (m_userId === null) {
			return;
		}
		m_dbController.deleteNote(m_userId, m_noteList[index].data.date_time, function(isSuccess, param1, param2) {
			if (isSuccess) {
				console.log('deleteNote operation:' + param1 + ' item:' + JSON.stringify(param2, null, 2));
				index = findNote(param2);
				if (index < 0) {
					console.log('not found item');
				} else {
					m_view.removeNote(m_noteList[index]);
					m_noteList.splice(index, 1);
				}
			} else {
				console.log('deleteNote failed:' + JSON.stringify(param1, null, 2));
				alert('error!!!');
			}
		});
	};
}
