var express = require('express');
var router = express.Router();
var myNoteServer = require('../myNoteServer');

router.get('/', function(req, res, next) {
	console.log("/ get note list=" + JSON.stringify(req.query));
	myNoteServer.getNoteList(req.query.user_id, function(isSuccess, result) {
		if (isSuccess) {
			res.json({is_success: "true", operation: "new", notes: result});
		} else {
			res.json({is_success: "false", error: result});
		}
	});
});

router.post('/add_note', function(req, res, next) {
	console.log("--- /add_note post ---");
	console.log("/note body=" + JSON.stringify(req.body));
	myNoteServer.updateNote(req.body.note, function(isSuccess, result) {
		if (isSuccess) {
		    res.json({is_success: "true", operation: "add", note: result});
		} else {
			res.json({is_success: "false", error: result});
		}
	});
});

router.post('/update_note', function(req, res, next) {
	console.log("--- /update_note post ---");
	console.log("body=" + JSON.stringify(req.body));
	myNoteServer.updateNote(req.body.note, function(isSuccess, result) {
		if (isSuccess) {
		    res.json({is_success: "true", operation : "update", note: result});
		} else {
			res.json({is_success: "false", error: result});
		}
	});
});

router.post('/delete_note', function(req, res, next) {
	console.log("--- /delete_note post ---");
	console.log("body=" + JSON.stringify(req.body));
	myNoteServer.deleteNote(req.body.note, function(isSuccess, result) {
		if (isSuccess) {
		    res.json({is_success: "true", operation: "delete", note: result});
		} else {
			res.json({is_success: "false", error: result});
		}
	});
});

router.delete('/', function(req, res, next) {
	console.log("--- /note delete ---");
	console.log("/note delete query=" + JSON.stringify(req.query));
	console.log("body=" + JSON.stringify(req.body));
	myNoteServer.clearAll(req.body.user_id, function(isSuccess, result) {
		if (isSuccess) {
			res.json({is_success: "true"});
		} else {
			res.json({is_success: "false", error: result});
		}
	});
});

module.exports = router;
